WelcomeWelcome | FAQFAQ | DownloadsDownloads | WikiWiki

Author Topic: Mono 5.0.1  (Read 531 times)

Offline mzlj10

  • WikiUser
  • *
  • Posts: 23
Mono 5.0.1
« on: July 17, 2017, 11:39:08 PM »
Hello,

I'm having a problem running mono 5.0.1.
I add extra repository for sce-import and download the latest version from mono-project.com and install it.
But when I want to run some mono programs get an error for
Code: [Select]
system.dllnotfound exception: libcIf I remember correct I was having problems before with mono, but someone made the extension for dCore and everything was working from then on.
Can someone help me with that? I think the problem is with linking libc library so mono can find it and use it. Any tips how to do it?

Best regards

Offline Jason W

  • Administrator
  • Hero Member
  • *****
  • Posts: 9306
Re: Mono 5.0.1
« Reply #1 on: July 18, 2017, 04:38:47 AM »
Which version of dCore are you using, and what is the extra repo entry?

Offline mzlj10

  • WikiUser
  • *
  • Posts: 23
Re: Mono 5.0.1
« Reply #2 on: July 18, 2017, 06:12:30 AM »
Version: dCore xenial
repo: http://download.mono-project.com/repo/ubuntu xenial main

http://www.mono-project.com/download/#download-lin-ubuntu I got the extra repo from this site.

Offline Jason W

  • Administrator
  • Hero Member
  • *****
  • Posts: 9306
Re: Mono 5.0.1
« Reply #3 on: July 18, 2017, 07:17:18 AM »
I saw the below workaround posted online.  I will look more into it when I have my dCore install available this evening.  Mono apparently looks for libc.so instead of libc.so.6

cd /lib/i386-linux-gnu/
ln -s libc.so.6 libc.so

If this works, it could be put in a mono extra repo startup script.

Offline Jason W

  • Administrator
  • Hero Member
  • *****
  • Posts: 9306
Re: Mono 5.0.1
« Reply #4 on: July 18, 2017, 04:28:37 PM »
What mono programs were you running in which there were errors?  I don't see any errors just invoking mono* commands. 

Offline mzlj10

  • WikiUser
  • *
  • Posts: 23
Re: Mono 5.0.1
« Reply #5 on: July 19, 2017, 05:55:46 AM »
I will try linking I will report the result.

I was trying Mono Debugger - MDebug. With mono 4.2.1 is everthing working ok, but with 5.0.1 got
Code: [Select]
system.dllnotfound exception: libcI have tried with basic mono aplication and I get no errors. But with MDebug I got the error.
I will try tommorow with my instalation and will report the result.

Here is the link of the website of the Mono Debugger. https://www.mdebug.com/
I don't know if I can just put the program here, because you have to pay for it.

Many thanks for your help, TinyCore cummunity is the best!  :D

Offline mzlj10

  • WikiUser
  • *
  • Posts: 23
Re: Mono 5.0.1
« Reply #6 on: July 19, 2017, 11:40:33 PM »
This linking is working to run just the basic app, but for my app, got the error that System.core is missing.
when mono-runtime 4.2.1 is installed i got the following output with the command 'gacutil -l' :

Code: [Select]
The following assemblies are installed into the GAC:
Accessibility, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
I18N, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
I18N.West, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
Mono.Data.Tds, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
Mono.Posix, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
Mono.Security, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
Mono.WebBrowser, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Configuration, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Core, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Data, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.EnterpriseServices, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Numerics, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Reactive.Core, Version=2.2.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35
System.Reactive.Interfaces, Version=2.2.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35
System.Reactive.Windows.Forms, Version=2.2.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35
System.Runtime.Serialization.Formatters.Soap, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Security, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Transactions, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Xml, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
Number of items = 22

but when mono-runtime 5.0.1 is installed get this output:

Code: [Select]
The following assemblies are installed into the GAC:
Mono.Security, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Configuration, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Security, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Xml, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
Number of items = 5

I figured it out, that when mono-complete 5.0.1 is installed, that all I had to do is create the link fo libc and then all is working.
I think that mono-runtime 5.0.1 don't install all the packages.
because when I sce-import mono-runtime 4.2.1 it download 17 package, with mono 5.0.1 but just 16. Maybe is this one package missing?
Can I manualy add the missing assemblies into the GAC?

I don't need mono-complete just mono-runtime, because I need that dCore OS size is smaller as possible.

Offline Jason W

  • Administrator
  • Hero Member
  • *****
  • Posts: 9306
Re: Mono 5.0.1
« Reply #7 on: July 20, 2017, 02:20:52 PM »
Hi mzlj10,
Could you start a sce-import session for mono-runtime version 4.2.1 and then stop when it is about to download or merge the packages, listing what is in /tmp/work/ ie 'ls /tmp/work', and then do the same for mono-runtime 5.0.1, and compare the two?  That would give the difference in packages that are installed.  And then we could see if installing the difference in packages would solve the issue.  Thanks.

Offline mzlj10

  • WikiUser
  • *
  • Posts: 23
Re: Mono 5.0.1
« Reply #8 on: July 20, 2017, 11:27:20 PM »
mono 4.2.1:
Code: [Select]
gcc-6-base
libc0.1
libc6
libc6.1
libgcc1
libmono-corlib4.5-cil
libmono-security4.0-cil
libmono-system-configuration4.0-cil
libmono-system-security4.0-cil
libmono-system-xml4.0-cil
libmono-system4.0-cil
mono-4.0-gac
mono-gac
mono-runtime
mono-runtime-common
mono-runtime-sgen
zlib1g

mono 5.0.1:
Code: [Select]
binutils
gcc-6-base
libc6
libgcc1
libmono-corlib4.5-cil
libmono-security4.0-cil
libmono-system-configuration4.0-cil
libmono-system-security4.0-cil
libmono-system-xml4.0-cil
libmono-system4.0-cil
mono-4.0-gac
mono-gac
mono-runtime
mono-runtime-common
mono-runtime-sgen
zlib1g

Offline Jason W

  • Administrator
  • Hero Member
  • *****
  • Posts: 9306
Re: Mono 5.0.1
« Reply #9 on: July 21, 2017, 07:03:38 AM »
Those libc0.1 and libc6.1 are just redundant entries for older package names for libc6 in the Xenial Packages file, so they don't bring in any packages themselves.  At this point there is nothing obvious to me to explain why the two versions of mono behave differently with mono-runtime installed. 

Offline mzlj10

  • WikiUser
  • *
  • Posts: 23
Re: Mono 5.0.1
« Reply #10 on: July 23, 2017, 10:41:46 PM »
This is what I get with 'gacutil -l' for mono-runtime 5.0.1:
Code: [Select]
gacutil -l
Couldn't find machine.config
The following assemblies are installed into the GAC:
Mono.Security, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Configuration, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Security, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Xml, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
Number of items = 5

and this is for mono-runtime 4.2.1:
Code: [Select]
The following assemblies are installed into the GAC:
Accessibility, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
I18N, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
I18N.West, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
Mono.Data.Tds, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
Mono.Posix, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
Mono.Security, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
Mono.WebBrowser, Version=4.0.0.0, Culture=neutral, PublicKeyToken=0738eb9f132ed756
System, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Configuration, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Core, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Data, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Drawing, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.EnterpriseServices, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Numerics, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Reactive.Core, Version=2.2.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35
System.Reactive.Interfaces, Version=2.2.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35
System.Reactive.Windows.Forms, Version=2.2.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35
System.Runtime.Serialization.Formatters.Soap, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Security, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a
System.Transactions, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Windows.Forms, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
System.Xml, Version=4.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089
Number of items = 22

Somehow mono-runtime 4.2.1 install more packages/dll. Is there a way to install manually this additional package for mono-runtime 5.0.1?
« Last Edit: July 23, 2017, 10:48:21 PM by mzlj10 »